function [TDhyp,HypIm] = TDhypothesis_cc(opts,image,BU_S,BU_P,S_distU,P_distU,RGB_topics,number_of_topics,pos2)
% Compute top-down hypothesis of illuminant color 
% TDhyp contains the hypotheses
% HypIm is halucination of the color of the image based on the SHAPE and Location cue (it is not used in the program)
    
im=read_im_NTSC_SHI(opts,image);

wtP=P_distU(:,BU_P)';
wtS=S_distU(:,BU_S)';

[wt2,td2,E2,PP] = plsa2(wtS+eps,ones(size(wtS)),wtP+eps,.00001,0,0);        % the color cue is not used

%compute color patches
im3=color_gauss(im,8);                           % CHECK IF COLOR SCALE IS CORRECT
RR=im3(:,:,1);GG=im3(:,:,2);BB=im3(:,:,3);

pos3=(pos2(:,1)-1)*size(im,1)+pos2(:,2);
Rpatch=RR(pos3); Gpatch=GG(pos3); Bpatch=BB(pos3);

[max1,max2] = max((wtP.*wtS).*(ones(size(wtP,1),1)*td2'),[],2);

dist=hist(max2,(1:number_of_topics));
dist=dist/sum(dist);

TDtopics=(1:number_of_topics);
TDtopics=TDtopics(dist>0.05);

Eilluminant2=[];ES=[];
HypIm=zeros(max(pos2(:,2)/16)*max(pos2(:,1)/16),3);
pos4=(pos2(:,1)/16-1)*max(pos2(:,2)/16)+pos2(:,2)/16;          %  coordinates in HypIm
for gg=1:length(TDtopics)                  % for all the topics present
   maskC=(max2==TDtopics(gg));             % pixels which are assigned to topic TDtopics(gg)      
   Eilluminant=[sum(Rpatch(maskC)),sum(Gpatch(maskC)),sum(Bpatch(maskC))]./RGB_topics(TDtopics(gg),:);           
   Eilluminant=Eilluminant./norm(Eilluminant); 
   TDhyp(gg,:)=Eilluminant;
    HypIm(pos4(maskC),:)=ones(sum(maskC),1)*RGB_topics(TDtopics(gg),:)*255*sqrt(3);
end
HypIm=reshape(HypIm,max(pos2(:,2)/16),max(pos2(:,1)/16),3);

